Bug 2249646 - Review Request: pam-ssh-auth-info - PAM authentication based on SSH authentication information
Summary: Review Request: pam-ssh-auth-info - PAM authentication based on SSH authenti...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Michel Lind
QA Contact: Fedora Extras Quality Assurance
URL: https://github.eero.häkkinen.fi/%{na...
Whiteboard:
Depends On:
Blocks: FE-NEEDSPONSOR
TreeView+ depends on / blocked
 
Reported: 2023-11-14 14:58 UTC by Jonathan McDowell
Modified: 2024-01-25 00:37 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2024-01-19 02:41:48 UTC
Type: ---
Embargoed:
michel: fedora-review+


Attachments (Terms of Use)
The .spec file difference from Copr build 6634727 to 6634816 (470 bytes, patch)
2023-11-14 15:29 UTC, Fedora Review Service
no flags Details | Diff
The .spec file difference from Copr build 6634816 to 6752950 (1.11 KB, patch)
2023-12-14 12:20 UTC, Fedora Review Service
no flags Details | Diff
The .spec file difference from Copr build 6752950 to 6782728 (829 bytes, patch)
2023-12-22 04:37 UTC, Fedora Review Service
no flags Details | Diff

Description Jonathan McDowell 2023-11-14 14:58:51 UTC
Spec URL: https://the.earth.li/~noodles/pam-ssh-auth-info/pam-ssh-auth-info.spec
SRPM URL: https://the.earth.li/~noodles/pam-ssh-auth-info/pam-ssh-auth-info-1.8.20230906-1.src.rpm
Description:
The pam_ssh_auth_info.so PAM module is designed to succeed or fail
authentication based on SSH authentication information consisting of a
list of successfully completed authentication methods and public
credentials (e.g. keys) used to authenticate the user. One use is to
select whether to load other modules based on this test.
Fedora Account System Username: u1f35c

Comment 1 Jonathan McDowell 2023-11-14 15:03:00 UTC
I'm a long time Debian Developer, but this is my first Fedora package. I'm hoping to convince @michel to sponsor the upload once it's reviewed.

Comment 2 Fedora Review Service 2023-11-14 15:04:19 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/6634727
(failed)

Build log:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2249646-pam-ssh-auth-info/fedora-rawhide-x86_64/06634727-pam-ssh-auth-info/builder-live.log.gz

Please make sure the package builds successfully at least for Fedora Rawhide.

- If the build failed for unrelated reasons (e.g. temporary network
  unavailability), please ignore it.
- If the build failed because of missing BuildRequires, please make sure they
  are listed in the "Depends On" field


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 3 Jonathan McDowell 2023-11-14 15:23:15 UTC
Dependencies fixed; mock rawhide build logs at https://the.earth.li/~noodles/pam-ssh-auth-info/result/

[fedora-review-service-build]

Comment 4 Fedora Review Service 2023-11-14 15:29:37 UTC
Created attachment 1999354 [details]
The .spec file difference from Copr build 6634727 to 6634816

Comment 5 Fedora Review Service 2023-11-14 15:29:39 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/6634816
(succeeded)

Review template:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2249646-pam-ssh-auth-info/fedora-rawhide-x86_64/06634816-pam-ssh-auth-info/fedora-review/review.txt

Please take a look if any issues were found.

---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 6 Michel Lind 2023-12-13 16:04:23 UTC
Taking this review, I can sponsor

Comment 7 Michel Lind 2023-12-13 16:33:02 UTC
Some quick notes

- Fedora is migrating to SPDX license identifiers
https://fedoraproject.org/wiki/Changes/SPDX_Licenses_Phase_3

❯ license-fedora2spdx "GPLv3"
GPL-3.0-only

- per the debian/copyright, and given this actually has both COPYING and COPYING.LESSER, you actually want
License: GPL-3.0-or-later AND LGPL-3.0-or-later

and document the license breakdown in a comment above (we don't have as structured a way to declare this as Debian unfortunately)

$ license-fedora2spdx "GPLv3+"
GPL-3.0-or-later

$ license-fedora2spdx "LGPLv3+"
LGPL-3.0-or-later

e.g.

# GPL-3.0-or-later: *
# LGPL-3.0-or-later: pam_*.c *.h
License: GPL-3.0-or-later AND LGPL-3.0-or-later

- I'd recommend using %autosetup over %setup -q -- in case you need to apply patches later on, it is easier (e.g. %autosetup -p1 will apply every listed patches with -p1)

- rm -rf $RPM_BUILD_ROOT is no longer needed, see e.g.
https://docs.fedoraproject.org/en-US/package-maintainers/Packaging_Tutorial_GNU_Hello/

(I think the page documenting the cleanup is no longer up, it's been a while)

- packager preference: I like having one BuildRequires per line, that makes the deltas easier to parse if you add dependency. Not blocking the review though

- %doc is empty, do you mean to do %doc README.md ?

- you also need

%license COPYING
%license COPYING.LESSER

(they can be combined on the same line if you want)

Comment 8 Jonathan McDowell 2023-12-14 12:16:25 UTC
Think I've addressed all those (I agree with the single build dep per line, didn't realise that was an option, so thanks) & updated the package URLs.

[fedora-review-service-build]

Comment 9 Fedora Review Service 2023-12-14 12:20:15 UTC
Created attachment 2004269 [details]
The .spec file difference from Copr build 6634816 to 6752950

Comment 10 Fedora Review Service 2023-12-14 12:20:18 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/6752950
(succeeded)

Review template:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2249646-pam-ssh-auth-info/fedora-rawhide-x86_64/06752950-pam-ssh-auth-info/fedora-review/review.txt

Please take a look if any issues were found.


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 11 Michel Lind 2023-12-21 03:26:05 UTC
Apologies for the delay!

One thing I missed earlier: the Release field should be 1%{?dist}

(try e.g. `rpmdev-newspec foo` and see the output). This ensures that when the spec is build for different releases, that release gets added. e.g. 1.fc40 (Rawhide), 1.fc39, 1.el9. The ? means this is also fine even if dist is not defined.

more change requests in the fedora-review output below (look for the items starting with [!])

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- If your application is a C or C++ application you must list a
  BuildRequires against gcc, gcc-c++ or clang.
  Note: No gcc, gcc-c++ or clang found in BuildRequires
  See: https://docs.fedoraproject.org/en-US/packaging-guidelines/C_and_C++/
  => add BuildRequires: gcc
- Dist tag is present.
  => see explanation at the top

===== MUST items =====

C/C++:
[-]: Provides: bundled(gnulib) in place as required.
     Note: Sources not installed
     => seems to be a false positive
[x]: Package does not contain kernel modules.
[-]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Header files in -devel subpackage, if present.
[x]: Package does not contain any libtool archives (.la)
[x]: Package contains no static executables.
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "GNU Lesser General Public License,
     Version 3", "GNU Lesser General Public License v3.0 or later", "GNU
     General Public License v3.0 or later", "GNU Lesser General Public
     License v3.0 or later GNU General Public License v3.0 or later". 10
     files have unknown license. Detailed output of licensecheck in
     /home/michel/src/fedora/reviews/try2/2249646-pam-ssh-auth-
     info/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[x]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[!]: Package must own all directories that it creates.
     Note: Directories without known owners: /usr/lib64/security
     => need to Requires: pam%{?_isa}
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.
     => missing pam, see above
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: The License field must be a valid SPDX expression.
[x]: Package requires other packages for directories it uses.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 4353 bytes in 1 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[!]: Uses parallel make %{?_smp_mflags} macro.
     => use %make_build not make
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Fully versioned dependency in subpackages if applicable.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Package should not use obsolete m4 macros
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: pam-ssh-auth-info-1.8.20230906-1.x86_64.rpm
          pam-ssh-auth-info-debuginfo-1.8.20230906-1.x86_64.rpm
          pam-ssh-auth-info-debugsource-1.8.20230906-1.x86_64.rpm
          pam-ssh-auth-info-1.8.20230906-1.src.rpm
============================ rpmlint session starts ============================
rpmlint: 2.4.0
configuration:
    /usr/lib/python3.11/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmp40fgtdpt')]
checks: 31, packages: 4

pam-ssh-auth-info.x86_64: E: pam-unauthorized-module pam_ssh_auth_info.so
 4 packages and 0 specfiles checked; 1 errors, 0 warnings, 1 badness; has taken 0.4 s 




Rpmlint (debuginfo)
-------------------
Checking: pam-ssh-auth-info-debuginfo-1.8.20230906-1.x86_64.rpm
============================ rpmlint session starts ============================
rpmlint: 2.4.0
configuration:
    /usr/lib/python3.11/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
rpmlintrc: [PosixPath('/tmp/tmpx9ounaxt')]
checks: 31, packages: 1

 1 packages and 0 specfiles checked; 0 errors, 0 warnings, 0 badness; has taken 0.2 s 





Rpmlint (installed packages)
----------------------------
============================ rpmlint session starts ============================
rpmlint: 2.5.0
configuration:
    /usr/lib/python3.12/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 32, packages: 3

pam-ssh-auth-info.x86_64: E: pam-unauthorized-module pam_ssh_auth_info.so
 3 packages and 0 specfiles checked; 1 errors, 0 warnings, 16 filtered, 1 badness; has taken 0.6 s 



Unversioned so-files
--------------------
pam-ssh-auth-info: /usr/lib64/security/pam_ssh_auth_info.so

Source checksums
----------------
https://github.com/eehakkin/pam-ssh-auth-info/archive/refs/tags/1.8.20230906.tar.gz#/pam-ssh-auth-info-1.8.20230906.tar.gz :
  CHECKSUM(SHA256) this package     : f15e88b268e2244b75a6a986bb6fffbef7b72e77c412e974e8415c7156052213
  CHECKSUM(SHA256) upstream package : f15e88b268e2244b75a6a986bb6fffbef7b72e77c412e974e8415c7156052213


Requires
--------
pam-ssh-auth-info (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libpam.so.0()(64bit)
    libpam.so.0(LIBPAM_1.0)(64bit)
    libpam.so.0(LIBPAM_EXTENSION_1.0)(64bit)
    rtld(GNU_HASH)

pam-ssh-auth-info-debuginfo (rpmlib, GLIBC filtered):

pam-ssh-auth-info-debugsource (rpmlib, GLIBC filtered):



Provides
--------
pam-ssh-auth-info:
    pam-ssh-auth-info
    pam-ssh-auth-info(x86-64)

pam-ssh-auth-info-debuginfo:
    debuginfo(build-id)
    pam-ssh-auth-info-debuginfo
    pam-ssh-auth-info-debuginfo(x86-64)

pam-ssh-auth-info-debugsource:
    pam-ssh-auth-info-debugsource
    pam-ssh-auth-info-debugsource(x86-64)



Generated by fedora-review 0.10.0 (e79b66b) last change: 2023-07-24
Command line :/usr/bin/fedora-review -b 2249646
Buildroot used: fedora-rawhide-x86_64
Active plugins: Shell-api, Generic, C/C++
Disabled plugins: Python, PHP, R, Haskell, SugarActivity, Perl, Ocaml, fonts, Java
Disabled flags: EXARCH, EPEL6, EPEL7, DISTTAG, BATCH

Comment 12 Jonathan McDowell 2023-12-21 13:27:38 UTC
Spec URL: https://the.earth.li/~noodles/pam-ssh-auth-info/pam-ssh-auth-info.spec
SRPM URL: https://the.earth.li/~noodles/pam-ssh-auth-info/pam-ssh-auth-info-1.8.20230906-1.fc38.src.rpm

Ah, neat, that's much handier than the manual requirement for a dist fixup that Debian has. Tests enabled, buildrequires/requires fixed up.

Do I need to do something about rpmlint's "E: pam-unauthorized-module pam_ssh_auth_info.so" complaint? I couldn't figure out what the appropriate action was.

Comment 13 Fedora Review Service 2023-12-22 04:37:02 UTC
Created attachment 2005351 [details]
The .spec file difference from Copr build 6752950 to 6782728

Comment 14 Fedora Review Service 2023-12-22 04:37:04 UTC
Copr build:
https://copr.fedorainfracloud.org/coprs/build/6782728
(succeeded)

Review template:
https://download.copr.fedorainfracloud.org/results/@fedora-review/fedora-review-2249646-pam-ssh-auth-info/fedora-rawhide-x86_64/06782728-pam-ssh-auth-info/fedora-review/review.txt

Please take a look if any issues were found.


---
This comment was created by the fedora-review-service
https://github.com/FrostyX/fedora-review-service

If you want to trigger a new Copr build, add a comment containing new
Spec and SRPM URLs or [fedora-review-service-build] string.

Comment 15 Michel Lind 2023-12-30 02:07:10 UTC
(In reply to Jonathan McDowell from comment #12)
> 
> Do I need to do something about rpmlint's "E: pam-unauthorized-module
> pam_ssh_auth_info.so" complaint? I couldn't figure out what the appropriate
> action was.

Nah, I checked and other PAM modules have the same rpmlint errors. Likely something we need to clean up on the rpmlint sides.

I think that's all the issues addressed, APPROVED

I've added you to the packager group, you'll need to log out and log back into accounts.fedoraproject.org (and probably src.fedoraproject.org as well to be sure) for the permissions to sync.

Welcome!

Comment 16 Fedora Admin user for bugzilla script actions 2024-01-08 14:40:42 UTC
The Pagure repository was created at https://src.fedoraproject.org/rpms/pam-ssh-auth-info

Comment 17 Fedora Update System 2024-01-10 15:07:03 UTC
FEDORA-2024-e45904e698 has been submitted as an update to Fedora 38. https://bodhi.fedoraproject.org/updates/FEDORA-2024-e45904e698

Comment 18 Fedora Update System 2024-01-10 15:07:04 UTC
FEDORA-2024-28d8ebbf06 has been submitted as an update to Fedora 39. https://bodhi.fedoraproject.org/updates/FEDORA-2024-28d8ebbf06

Comment 19 Fedora Update System 2024-01-11 01:40:39 UTC
FEDORA-2024-28d8ebbf06 has been pushed to the Fedora 39 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --refresh --advisory=FEDORA-2024-28d8ebbf06 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2024-28d8ebbf06

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 20 Fedora Update System 2024-01-11 02:09:30 UTC
FEDORA-2024-e45904e698 has been pushed to the Fedora 38 testing repository.
Soon you'll be able to install the update with the following command:
`sudo dnf install --enablerepo=updates-testing --refresh --advisory=FEDORA-2024-e45904e698 \*`
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2024-e45904e698

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 21 Fedora Update System 2024-01-16 11:29:06 UTC
FEDORA-EPEL-2024-1580578a24 has been submitted as an update to Fedora EPEL 9. https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2024-1580578a24

Comment 22 Fedora Update System 2024-01-17 00:44:42 UTC
FEDORA-EPEL-2024-1580578a24 has been pushed to the Fedora EPEL 9 testing repository.

You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-EPEL-2024-1580578a24

See also https://fedoraproject.org/wiki/QA:Updates_Testing for more information on how to test updates.

Comment 23 Fedora Update System 2024-01-19 02:41:48 UTC
FEDORA-2024-28d8ebbf06 has been pushed to the Fedora 39 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 24 Fedora Update System 2024-01-19 03:24:43 UTC
FEDORA-2024-e45904e698 has been pushed to the Fedora 38 stable repository.
If problem still persists, please make note of it in this bug report.

Comment 25 Fedora Update System 2024-01-25 00:37:37 UTC
FEDORA-EPEL-2024-1580578a24 has been pushed to the Fedora EPEL 9 stable repository.
If problem still persists, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.